Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 4108)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 4109)
@@ -6134,26 +6371,26 @@
 !--             correction is needed to overcome numerical instabilities caused
 !--             by a not sufficient reduction of divergences near topography.
-                div = ( ( ( u_comp + gu ) * ( ibit27 + ibit28 + ibit29 )      &
+                div = ( ( ( u_comp + gu ) * ( ibit18 + ibit19 + ibit20 )      &
                   - ( u(k+1,j,i) + u(k,j,i)   )                               & 
                                     * (                                       &
-                     REAL( IBITS(advc_flags_1(k,j,i-1),27,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_1(k,j,i-1),28,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_1(k,j,i-1),29,1), KIND = wp )     &
+                     REAL( IBITS(advc_flags_m(k,j,i-1),18,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_m(k,j,i-1),19,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_m(k,j,i-1),20,1), KIND = wp )     &
                                       )                                       &
                   ) * ddx                                                     &
-              +   ( ( v_comp + gv ) * ( ibit30 + ibit31 + ibit32 )            &
+              +   ( ( v_comp + gv ) * ( ibit21 + ibit22 + ibit23 )            &
                   - ( v(k+1,j,i) + v(k,j,i)   )                               &
                                     * (                                       &
-                     REAL( IBITS(advc_flags_1(k,j-1,i),30,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_1(k,j-1,i),31,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_2(k,j-1,i),0,1),  KIND = wp )     &
+                     REAL( IBITS(advc_flags_m(k,j-1,i),21,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_m(k,j-1,i),22,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_m(k,j-1,i),23,1),  KIND = wp )    &
                                       )                                       &
                   ) * ddy                                                     &
-              +   ( w_comp * rho_air(k+1) * ( ibit33 + ibit34 + ibit35 )      &
+              +   ( w_comp * rho_air(k+1) * ( ibit24 + ibit25 + ibit26 )      &
                 - ( w(k,j,i)   + w(k-1,j,i)   ) * rho_air(k)                  &
                                     * (                                       &
-                     REAL( IBITS(advc_flags_2(k-1,j,i),1,1), KIND = wp )      &
-                   + REAL( IBITS(advc_flags_2(k-1,j,i),2,1), KIND = wp )      &
-                   + REAL( IBITS(advc_flags_2(k-1,j,i),3,1), KIND = wp )      &
+                     REAL( IBITS(advc_flags_m(k-1,j,i),24,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_m(k-1,j,i),25,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_m(k-1,j,i),26,1), KIND = wp )     &
                                       )                                       & 
                   ) * drho_air_zw(k) * ddzu(k+1)                              &
@@ -6210,9 +6447,9 @@
                 u_comp_l = u(k+1,j,i) + u(k,j,i) - gu
                 flux_l   = u_comp_l * (                                     &
-                            37.0_wp * ( w(k,j,i) + w(k,j,i-1)   )              &
+                            37.0_wp * ( w(k,j,i)   + w(k,j,i-1)   )              &
                           -  8.0_wp * ( w(k,j,i+1) + w(k,j,i-2) )              &
                           +           ( w(k,j,i+2) + w(k,j,i-3) ) ) * adv_mom_5
                 diss_l   = - ABS( u_comp_l ) * (                            &
-                            10.0_wp * ( w(k,j,i) - w(k,j,i-1)   )              &
+                            10.0_wp * ( w(k,j,i)   - w(k,j,i-1)   )              &
                           -  5.0_wp * ( w(k,j,i+1) - w(k,j,i-2) )              &
                           +           ( w(k,j,i+2) - w(k,j,i-3) ) ) * adv_mom_5
@@ -6238,9 +6475,9 @@
                 v_comp_s = v(k+1,j,i) + v(k,j,i) - gv
                 flux_s   = v_comp_s * (                                     &
-                           37.0_wp * ( w(k,j,i) + w(k,j-1,i)   )               &
+                           37.0_wp * ( w(k,j,i)   + w(k,j-1,i) )               &
                          -  8.0_wp * ( w(k,j+1,i) +w(k,j-2,i)  )               &
                          +           ( w(k,j+2,i) + w(k,j-3,i) ) ) * adv_mom_5
                 diss_s   = - ABS( v_comp_s ) * (                            &
-                           10.0_wp * ( w(k,j,i) - w(k,j-1,i)   )               &
+                           10.0_wp * ( w(k,j,i)   - w(k,j-1,i) )               &
                          -  5.0_wp * ( w(k,j+1,i) - w(k,j-2,i) )               &
                          +           ( w(k,j+2,i) - w(k,j-3,i) ) ) * adv_mom_5
@@ -6253,24 +6490,24 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit35 = REAL( IBITS(advc_flags_2(k,j,i),3,1), KIND = wp )
-                ibit34 = REAL( IBITS(advc_flags_2(k,j,i),2,1), KIND = wp )
-                ibit33 = REAL( IBITS(advc_flags_2(k,j,i),1,1), KIND = wp )
-
-                k_ppp = k + 3 * ibit35
-                k_pp  = k + 2 * ( 1 - ibit33  )
-                k_mm  = k - 2 * ibit35
+                ibit26 = REAL( IBITS(advc_flags_m(k,j,i),26,1), KIND = wp )
+                ibit25 = REAL( IBITS(advc_flags_m(k,j,i),25,1), KIND = wp )
+                ibit24 = REAL( IBITS(advc_flags_m(k,j,i),24,1), KIND = wp )
+
+                k_ppp = k + 3 * ibit26
+                k_pp  = k + 2 * ( 1 - ibit24  )
+                k_mm  = k - 2 * ibit26
 
                 w_comp = w(k+1,j,i) + w(k,j,i)
                 flux_t = w_comp * rho_air(k+1) * (                           &
-                          ( 37.0_wp * ibit35 * adv_mom_5                        &
-                       +     7.0_wp * ibit34 * adv_mom_3                        &
-                       +              ibit33 * adv_mom_1                        &
+                          ( 37.0_wp * ibit26 * adv_mom_5                        &
+                       +     7.0_wp * ibit25 * adv_mom_3                        &
+                       +              ibit24 * adv_mom_1                        &
                           ) *                                                &
                              ( w(k+1,j,i)  + w(k,j,i)     )                  &
-                   -      (  8.0_wp * ibit35 * adv_mom_5                        &
-                       +              ibit34 * adv_mom_3                        &
+                   -      (  8.0_wp * ibit26 * adv_mom_5                        &
+                       +              ibit25 * adv_mom_3                        &
                           ) *                                                &
                              ( w(k_pp,j,i)  + w(k-1,j,i)  )                  &
-                   +      (           ibit35 * adv_mom_5                        &
+                   +      (           ibit26 * adv_mom_5                        &
                           ) *                                                &
                              ( w(k_ppp,j,i) + w(k_mm,j,i) )                  &
@@ -6278,14 +6515,14 @@
 
                 diss_t = - ABS( w_comp ) * rho_air(k+1) * (                  &
-                          ( 10.0_wp * ibit35 * adv_mom_5                        &
-                       +     3.0_wp * ibit34 * adv_mom_3                        &
-                       +              ibit33 * adv_mom_1                        &
+                          ( 10.0_wp * ibit26 * adv_mom_5                        &
+                       +     3.0_wp * ibit25 * adv_mom_3                        &
+                       +              ibit24 * adv_mom_1                        &
                           ) *                                                &
                              ( w(k+1,j,i)   - w(k,j,i)    )                  &
-                   -      (  5.0_wp * ibit35 * adv_mom_5                        &
-                       +              ibit34 * adv_mom_3                        &
+                   -      (  5.0_wp * ibit26 * adv_mom_5                        &
+                       +              ibit25 * adv_mom_3                        &
                           ) *                                                &
                              ( w(k_pp,j,i)  - w(k-1,j,i)  )                  &
-                   +      (           ibit35 * adv_mom_5                        &
+                   +      (           ibit26 * adv_mom_5                        &
                           ) *                                                &
                              ( w(k_ppp,j,i) - w(k_mm,j,i) )                  &
Index: /palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4108)
+++ /palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4109)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! Pass integer flag array as well as boundary flags to WS scalar advection 
+! routine
 ! 
 ! Former revisions:
@@ -249,5 +250,13 @@
 
     USE control_parameters,                                                    &
-        ONLY:  debug_output,                                                   &
+        ONLY:  bc_dirichlet_l,                                                 &
+               bc_dirichlet_n,                                                 &
+               bc_dirichlet_r,                                                 &
+               bc_dirichlet_s,                                                 &
+               bc_radiation_l,                                                 &
+               bc_radiation_n,                                                 &
+               bc_radiation_r,                                                 &
+               bc_radiation_s,                                                 &                                                                
+               debug_output,                                                   &
                dt_3d, dt_do2d_xy, intermediate_timestep_count,                 &
                intermediate_timestep_count_max, large_scale_forcing,           &
@@ -266,5 +275,6 @@
 
     USE indices,                                                               &
-        ONLY:  nbgp, nxl, nxlg, nxr, nxrg, nys, nysg, nyn, nyng, nzb, nzt,     &
+        ONLY:  advc_flags_s,                                                   &
+               nbgp, nxl, nxlg, nxr, nxrg, nys, nysg, nyn, nyng, nzb, nzt,     &
                wall_flags_0
 
@@ -1483,5 +1493,9 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( ws_scheme_sca )  THEN
-                   CALL advec_s_ws( qc, 'qc' )
+                   CALL advec_s_ws( advc_flags_s, qc, 'qc',                    &
+                                    bc_dirichlet_l  .OR.  bc_radiation_l,      &
+                                    bc_dirichlet_n  .OR.  bc_radiation_n,      &
+                                    bc_dirichlet_r  .OR.  bc_radiation_r,      &
+                                    bc_dirichlet_s  .OR.  bc_radiation_s )
                 ELSE
                    CALL advec_s_pw( qc )
@@ -1569,5 +1583,9 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( ws_scheme_sca )  THEN
-                   CALL advec_s_ws( nc, 'nc' )
+                   CALL advec_s_ws( advc_flags_s, nc, 'nc',                    &
+                                    bc_dirichlet_l  .OR.  bc_radiation_l,      &
+                                    bc_dirichlet_n  .OR.  bc_radiation_n,      &
+                                    bc_dirichlet_r  .OR.  bc_radiation_r,      &
+                                    bc_dirichlet_s  .OR.  bc_radiation_s )
                 ELSE
                    CALL advec_s_pw( nc )
@@ -1662,5 +1680,9 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( ws_scheme_sca )  THEN
-                   CALL advec_s_ws( qr, 'qr' )
+                   CALL advec_s_ws( advc_flags_s, qr, 'qr',                    &
+                                    bc_dirichlet_l  .OR.  bc_radiation_l,      &
+                                    bc_dirichlet_n  .OR.  bc_radiation_n,      &
+                                    bc_dirichlet_r  .OR.  bc_radiation_r,      &
+                                    bc_dirichlet_s  .OR.  bc_radiation_s )
                 ELSE
                    CALL advec_s_pw( qr )
@@ -1748,5 +1770,9 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( ws_scheme_sca )  THEN
-                   CALL advec_s_ws( nr, 'nr' )
+                   CALL advec_s_ws( advc_flags_s, nr, 'nr',                    &
+                                    bc_dirichlet_l  .OR.  bc_radiation_l,      &
+                                    bc_dirichlet_n  .OR.  bc_radiation_n,      &
+                                    bc_dirichlet_r  .OR.  bc_radiation_r,      &
+                                    bc_dirichlet_s  .OR.  bc_radiation_s )
                 ELSE
                    CALL advec_s_pw( nr )
@@ -1842,7 +1868,11 @@
           THEN
              IF ( ws_scheme_sca )  THEN
-                CALL advec_s_ws( i, j, qc, 'qc', flux_s_qc,       &
-                                 diss_s_qc, flux_l_qc, diss_l_qc, &
-                                 i_omp_start, tn )
+                CALL advec_s_ws( advc_flags_s, i, j, qc, 'qc', flux_s_qc,      &
+                                 diss_s_qc, flux_l_qc, diss_l_qc,              &
+                                 i_omp_start, tn,                              &
+                                 bc_dirichlet_l  .OR.  bc_radiation_l,         &
+                                 bc_dirichlet_n  .OR.  bc_radiation_n,         &
+                                 bc_dirichlet_r  .OR.  bc_radiation_r,         &
+                                 bc_dirichlet_s  .OR.  bc_radiation_s )
              ELSE
                 CALL advec_s_pw( i, j, qc )
@@ -1897,7 +1927,11 @@
           IF ( timestep_scheme(1:5) == 'runge' )  THEN
              IF ( ws_scheme_sca )  THEN
-                CALL advec_s_ws( i, j, nc, 'nc', flux_s_nc,    &
-                              diss_s_nc, flux_l_nc, diss_l_nc, &
-                              i_omp_start, tn )
+                CALL advec_s_ws( advc_flags_s, i, j, nc, 'nc', flux_s_nc,      &
+                                 diss_s_nc, flux_l_nc, diss_l_nc,              &
+                                 i_omp_start, tn,                              &
+                                 bc_dirichlet_l  .OR.  bc_radiation_l,         &
+                                 bc_dirichlet_n  .OR.  bc_radiation_n,         &
+                                 bc_dirichlet_r  .OR.  bc_radiation_r,         &
+                                 bc_dirichlet_s  .OR.  bc_radiation_s )
              ELSE
                 CALL advec_s_pw( i, j, nc )
@@ -1958,7 +1992,11 @@
           THEN
              IF ( ws_scheme_sca )  THEN
-                CALL advec_s_ws( i, j, qr, 'qr', flux_s_qr,       &
-                                 diss_s_qr, flux_l_qr, diss_l_qr, &
-                                 i_omp_start, tn )
+                CALL advec_s_ws( advc_flags_s, i, j, qr, 'qr', flux_s_qr,      &
+                                 diss_s_qr, flux_l_qr, diss_l_qr,              &
+                                 i_omp_start, tn,                              &
+                                 bc_dirichlet_l  .OR.  bc_radiation_l,         &
+                                 bc_dirichlet_n  .OR.  bc_radiation_n,         &
+                                 bc_dirichlet_r  .OR.  bc_radiation_r,         &
+                                 bc_dirichlet_s  .OR.  bc_radiation_s )
              ELSE
                 CALL advec_s_pw( i, j, qr )
@@ -2013,7 +2051,11 @@
           IF ( timestep_scheme(1:5) == 'runge' )  THEN
              IF ( ws_scheme_sca )  THEN
-                CALL advec_s_ws( i, j, nr, 'nr', flux_s_nr,    &
-                              diss_s_nr, flux_l_nr, diss_l_nr, &
-                              i_omp_start, tn )
+                CALL advec_s_ws( advc_flags_s, i, j, nr, 'nr', flux_s_nr,      &
+                                 diss_s_nr, flux_l_nr, diss_l_nr,              &
+                                 i_omp_start, tn,                              &
+                                 bc_dirichlet_l  .OR.  bc_radiation_l,         &
+                                 bc_dirichlet_n  .OR.  bc_radiation_n,         &
+                                 bc_dirichlet_r  .OR.  bc_radiation_r,         &
+                                 bc_dirichlet_s  .OR.  bc_radiation_s )
              ELSE
                 CALL advec_s_pw( i, j, nr )
Index: /palm/trunk/SOURCE/chem_modules.f90
===================================================================
--- /palm/trunk/SOURCE/chem_modules.f90	(revision 4108)
+++ /palm/trunk/SOURCE/chem_modules.f90	(revision 4109)
@@ -22,5 +22,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! +cs_advc_flags_s
 ! 
 ! Former revisions:
@@ -130,4 +130,7 @@
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  match_spec_voc_input  !< index of VOC input components matching the model's VOCs
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  match_spec_voc_model  !< index of VOC model species matching the input VOCs comp.
+    
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE  ::  cs_advc_flags_s !< flags used to degrade order of advection scheme for 
+                                                                     !< chemical species near walls and lateral boundaries
 
     LOGICAL ::  constant_top_csflux(99)   = .TRUE.   !< internal flag, set to .FALSE. if no top_csflux is prescribed
Index: /palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4108)
+++ /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4109)
@@ -22,5 +22,14 @@
 ! Current revisions:
 ! -----------------
-! 
+! - Decycling boundary conditions are only set at the ghost points not on the
+!   prognostic grid points 
+! - Allocation and initialization of special advection flags cs_advc_flags_s
+!   used for chemistry. These are exclusively used for chemical species in 
+!   order to distinguish from the usually-used flags which might be different
+!   when decycling is applied in combination with cyclic boundary conditions. 
+!   Moreover, cs_advc_flags_s considers extended zones around buildings where 
+!   first-order upwind scheme is applied for the horizontal advection terms, 
+!   in order to overcome high concentration peaks due to stationary numerical 
+!   oscillations caused by horizontal advection discretization.
 ! 
 ! Former revisions:
@@ -344,5 +353,5 @@
 
     USE advec_ws,                                                                                  &
-         ONLY:  advec_s_ws
+         ONLY:  advec_s_ws, ws_init_flags_scalar
 
     USE diffusion_s_mod,                                                                           &
@@ -353,5 +362,6 @@
 
     USE indices,                                                                                   &
-         ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nz, nzb, nzt, wall_flags_0
+         ONLY:  advc_flags_s,                                                                      &
+                nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nz, nzb, nzt, wall_flags_0
 
     USE pegrid,                                                                                    &
@@ -363,4 +373,12 @@
     USE control_parameters,                                                                        &
          ONLY:  bc_lr_cyc, bc_ns_cyc,                                                              &
+                bc_dirichlet_l,                                                                    &
+                bc_dirichlet_n,                                                                    &
+                bc_dirichlet_r,                                                                    &
+                bc_dirichlet_s,                                                                    &
+                bc_radiation_l,                                                                    &
+                bc_radiation_n,                                                                    &
+                bc_radiation_r,                                                                    &
+                bc_radiation_s,                                                                    &
                 debug_output,                                                                      &
                 dt_3d, humidity, initializing_actions, message_string,                             &
@@ -368,4 +386,5 @@
                 max_pr_user,                                                                       &
                 monotonic_limiter_z,                                                               &
+                scalar_advec,                                                                      &
                 timestep_scheme, use_prescribed_profile_data, ws_scheme_sca, air_chemistry
 
@@ -962,7 +981,7 @@
             IF ( boundary == 1  .AND.  nxl == 0 )  THEN
                ss = nxlg
-               ee = nxl+2
+               ee = nxl-1
             ELSEIF ( boundary == 2  .AND.  nxr == nx )  THEN
-               ss = nxr-2
+               ss = nxr+1
                ee = nxrg
             ENDIF
@@ -1026,7 +1045,7 @@
             IF ( boundary == 3  .AND.  nys == 0 )  THEN
                ss = nysg
-               ee = nys+2
+               ee = nys-1
             ELSEIF ( boundary == 4  .AND.  nyn == ny )  THEN
-               ss = nyn-2
+               ss = nyn+1
                ee = nyng
             ENDIF
@@ -1854,5 +1873,5 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE chem_init_internal
-
+ 
     USE pegrid
 
@@ -1921,4 +1940,102 @@
 
     ENDDO
+!
+!-- Set control flags for decycling only at lateral boundary cores, within the 
+!-- inner cores the decycle flag is set to .False.. Even though it does not 
+!-- affect the setting of chemistry boundary conditions, this flag is used to
+!-- set advection control flags appropriately. 
+    decycle_chem_lr = MERGE( decycle_chem_lr, .FALSE.,                         &
+                             nxl == 0  .OR.  nxr == nx )
+    decycle_chem_ns = MERGE( decycle_chem_ns, .FALSE.,                         &
+                             nys == 0  .OR.  nyn == ny )
+!
+!-- For some passive scalars decycling may be enabled. This case, the lateral 
+!-- boundary conditions are non-cyclic for these scalars (chemical species
+!-- and aerosols), while the other scalars may have
+!-- cyclic boundary conditions. However, large gradients near the boundaries
+!-- may produce stationary numerical oscillations near the lateral boundaries
+!-- when a higher-order scheme is applied near these boundaries. 
+!-- To get rid-off this, set-up additional flags that control the order of the 
+!-- scalar advection scheme near the lateral boundaries for passive scalars 
+!-- with decycling.
+    IF ( scalar_advec == 'ws-scheme' )  THEN
+       ALLOCATE( cs_advc_flags_s(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+!
+!--    In case of decyling, set Neumann boundary conditions for wall_flags_0 
+!--    bit 31 instead of cyclic boundary conditions.
+!--    Bit 31 is used to identify extended degradation zones (please see
+!--    following comment). 
+!--    Note, since several also other modules like Salsa or other future 
+!--    one may access this bit but may have other boundary conditions, the 
+!--    original value of wall_flags_0 bit 31 must not be modified. Hence, 
+!--    store the boundary conditions directly on cs_advc_flags_s. 
+!--    cs_advc_flags_s will be later overwritten in ws_init_flags_scalar and
+!--    bit 31 won't be used to control the numerical order. 
+!--    Initialize with flag 31 only. 
+       cs_advc_flags_s = 0
+       cs_advc_flags_s = MERGE( IBSET( cs_advc_flags_s, 31 ), 0,               &
+                                BTEST( wall_flags_0, 31 ) )
+
+       IF ( decycle_chem_ns )  THEN
+          IF ( nys == 0  )  THEN
+             DO  i = 1, nbgp     
+                cs_advc_flags_s(:,nys-i,:) = MERGE(                            &
+                                        IBSET( cs_advc_flags_s(:,nys,:), 31 ), &
+                                        IBCLR( cs_advc_flags_s(:,nys,:), 31 ), &
+                                        BTEST( cs_advc_flags_s(:,nys,:), 31 )  &
+                                                  )
+             ENDDO
+          ENDIF
+          IF ( nyn == ny )  THEN
+             DO  i = 1, nbgp  
+                cs_advc_flags_s(:,nyn+i,:) = MERGE(                            &
+                                        IBSET( cs_advc_flags_s(:,nyn,:), 31 ), &
+                                        IBCLR( cs_advc_flags_s(:,nyn,:), 31 ), &
+                                        BTEST( cs_advc_flags_s(:,nyn,:), 31 )  &
+                                                  )
+             ENDDO
+          ENDIF
+       ENDIF
+       IF ( .NOT. decycle_chem_lr )  THEN
+          IF ( nxl == 0  )  THEN
+             DO  i = 1, nbgp   
+                cs_advc_flags_s(:,:,nxl-i) = MERGE(                            &
+                                        IBSET( cs_advc_flags_s(:,:,nxl), 31 ), &
+                                        IBCLR( cs_advc_flags_s(:,:,nxl), 31 ), &
+                                        BTEST( cs_advc_flags_s(:,:,nxl), 31 )  &
+                                                  )
+             ENDDO
+          ENDIF
+          IF ( nxr == nx )  THEN 
+             DO  i = 1, nbgp   
+                cs_advc_flags_s(:,:,nxr+i) = MERGE(                            &
+                                        IBSET( cs_advc_flags_s(:,:,nxr), 31 ), &
+                                        IBCLR( cs_advc_flags_s(:,:,nxr), 31 ), &
+                                        BTEST( cs_advc_flags_s(:,:,nxr), 31 )  &
+                                                  )
+             ENDDO
+          ENDIF      
+       ENDIF
+!
+!--    To initialize advection flags appropriately, pass the boundary flags. 
+!--    The last argument indicates that a passive scalar is treated, where
+!--    the horizontal advection terms are degraded already 2 grid points before
+!--    the lateral boundary to avoid stationary oscillations at large-gradients. 
+!--    Also, extended degradation zones are applied, where horizontal advection of 
+!--    passive scalars is discretized by first-order scheme at all grid points 
+!--    that in the vicinity of buildings (<= 3 grid points). Even though no 
+!--    building is within the numerical stencil, first-order scheme is used. 
+!--    At fourth and fifth grid point the order of the horizontal advection scheme
+!--    is successively upgraded.
+!--    These extended degradation zones are used to avoid stationary numerical 
+!--    oscillations, which are responsible for high concentration maxima that may
+!--    appear under shear-free stable conditions. 
+       CALL ws_init_flags_scalar(                                              &
+                  bc_dirichlet_l  .OR.  bc_radiation_l  .OR.  decycle_chem_lr, &
+                  bc_dirichlet_n  .OR.  bc_radiation_n  .OR.  decycle_chem_ns, &
+                  bc_dirichlet_r  .OR.  bc_radiation_r  .OR.  decycle_chem_lr, &
+                  bc_dirichlet_s  .OR.  bc_radiation_s  .OR.  decycle_chem_ns, &
+                  cs_advc_flags_s, .TRUE. )
+    ENDIF
 !
 !-- Initial concentration of profiles is prescribed by parameters cs_profile
@@ -2650,5 +2767,9 @@
        IF ( timestep_scheme(1:5) == 'runge' )  THEN
           IF ( ws_scheme_sca )  THEN
-             CALL advec_s_ws( chem_species(ilsp)%conc, 'kc' )
+             CALL advec_s_ws( cs_advc_flags_s, chem_species(ilsp)%conc, 'kc',                      &
+                              bc_dirichlet_l  .OR.  bc_radiation_l  .OR.  decycle_chem_lr,         &
+                              bc_dirichlet_n  .OR.  bc_radiation_n  .OR.  decycle_chem_ns,         &
+                              bc_dirichlet_r  .OR.  bc_radiation_r  .OR.  decycle_chem_lr,         &
+                              bc_dirichlet_s  .OR.  bc_radiation_s  .OR.  decycle_chem_ns )
           ELSE
              CALL advec_s_pw( chem_species(ilsp)%conc )
@@ -2755,7 +2876,20 @@
        IF ( timestep_scheme(1:5) == 'runge' )  THEN
           IF ( ws_scheme_sca )  THEN
-             CALL advec_s_ws( i, j, chem_species(ilsp)%conc, 'kc', chem_species(ilsp)%flux_s_cs,   &
-                              chem_species(ilsp)%diss_s_cs, chem_species(ilsp)%flux_l_cs,          &
-                              chem_species(ilsp)%diss_l_cs, i_omp_start, tn, monotonic_limiter_z )
+             CALL advec_s_ws( cs_advc_flags_s,                                                     &
+                              i,                                                                   &
+                              j,                                                                   &
+                              chem_species(ilsp)%conc,                                             &
+                              'kc',                                                                &
+                              chem_species(ilsp)%flux_s_cs,                                        &
+                              chem_species(ilsp)%diss_s_cs,                                        &
+                              chem_species(ilsp)%flux_l_cs,                                        &
+                              chem_species(ilsp)%diss_l_cs,                                        &
+                              i_omp_start,                                                         &
+                              tn,                                                                  &
+                              bc_dirichlet_l  .OR.  bc_radiation_l  .OR.  decycle_chem_lr,         &
+                              bc_dirichlet_n  .OR.  bc_radiation_n  .OR.  decycle_chem_ns,         &
+                              bc_dirichlet_r  .OR.  bc_radiation_r  .OR.  decycle_chem_lr,         &
+                              bc_dirichlet_s  .OR.  bc_radiation_s  .OR.  decycle_chem_ns,         &
+                              monotonic_limiter_z )
           ELSE
              CALL advec_s_pw( i, j, chem_species(ilsp)%conc )
